// =====================================================================================================================
//  fennec, a free and open source game engine
//  Copyright © 2025 - 2026  Medusa Slockbower
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <https://www.gnu.org/licenses/>.
// =====================================================================================================================

#ifndef FENNEC_TEST_FILESYSTEM_H
#define FENNEC_TEST_FILESYSTEM_H

#include "../test.h"

#include <fennec/filesystem/file.h>
#include <fennec/filesystem/path.h>

namespace fennec::test
{

	inline void fennec_test_filesystem() {

		fennec_test_section("utilities");

		fennec_test_spacer(1);

		fennec_test_run(path::get_current(),                                       path(FENNEC_TEST_CWD));
		fennec_test_run(path("../" FENNEC_BUILD_NAME "/./test.sh").absolute(), path(FENNEC_TEST_CWD) / "test.sh");
		fennec_test_run(path("./test/../test.sh").absolute(),                  path(FENNEC_TEST_CWD) / "test.sh");
		fennec_test_run(path::get_current().parent(),                              path("../").absolute());

		fennec_test_spacer(2);


		fennec_test_section("file streams");

		fennec_test_spacer(1);

		file stream;
		char data[] = "Hello World!";
		fennec_test_run(stream.open("./test.txt", fmode_write | fmode_trunc), false);
		fennec_test_run(stream.write(data), sizeof(data));
		fennec_test_run(stream.close(), false);

		fennec_test_spacer(1);

		fennec_test_run(stream.open("./test.txt", fmode_read), false);
		fennec_test_run(stream.read(data), sizeof(data));
		fennec_test_run(cstring(data), cstring("Hello World!"));

		fennec_test_spacer(1);

		fennec_test_run(stream.open("./test.txt", fmode_read), false);
		fennec_test_run((stream = stream.copy("./copy.txt")).is_open(), true);
		fennec_test_run(stream.open("./copy.txt", fmode_read), false);
		fennec_test_run(stream.read(data), sizeof(data));
		fennec_test_run(cstring(data), cstring("Hello World!"));
		fennec_test_run(stream.erase(), false);

		fennec_test_spacer(1);

		fennec_test_run(stream.open("./test.txt", fmode_read), false);
		fennec_test_run(stream.rename("./rename.txt"), false);
		fennec_test_run(stream.open("./rename.txt", fmode_read), false);
		fennec_test_run(stream.read(data), sizeof(data));
		fennec_test_run(cstring(data), cstring("Hello World!"));
		fennec_test_run(stream.erase(), false);

		fennec_test_spacer(2);


		fennec_test_section("std streams");

		fennec_test_spacer(1);

		fennec_test_run(file::cout().write("Hello World!"), sizeof("Hello World!"));
		fennec_test_run(file::cerr().write("Hello World!"), sizeof("Hello World!"));

	}

}

#endif // FENNEC_TEST_FILESYSTEM_H
